#!C:/Users/user/AppData/Local/Programs/Python/Python39/python.exe
#Replace the above location with yours. E.g #!/usr/bin/python3 for Linux
import requests
from bs4 import BeautifulSoup
import json
import cgi
from lib.dbclass import EasyDB

class populationDB(EasyDB) :  
    def __init__(self):
        EasyDB.__init__(self, ["localhost", "myuser", "12345678", "mydb"])      
    # create    
    def create(self, country, population):
        sql = "INSERT INTO population (country, population) VALUES ('{}', '{}')".format(country, population)
        self.execute(sql)
    # read        
    def read(self, country):
        if country == "All" : 
            sql = "SELECT * FROM population"
            return self.fetchall(sql)
        else :
            sql = "SELECT * FROM population WHERE country='{}' ".format(country)
            return self.fetchone(sql)
    # update
    def update(self, country, population):
        sql = "UPDATE population SET population='{}' WHERE country='{}' ".format(population, country)
        self.execute(sql)
    # delete        
    def delete(self, country):
        if country == "All" : 
            sql = "DELETE FROM population"
        else :
            sql = "DELETE FROM population WHERE country='{}' ".format(country)
        self.execute(sql)
             
        
def get_population_from_web(target) :
    # Get the content of web page
    
    the_url = "https://www.worldometers.info/geography/alphabetical-list-of-countries/"
    r = requests.get(the_url)
    if r.status_code != 200:
        print('Download Err: '+r.url)
        exit()
    r_text = r.text
    '''   
    with open("temp/worldometers.html", 'r', encoding='utf-8') as f :
        r_text = f.read()
    '''
    # Crawl and analyze
    soup = BeautifulSoup(r_text, "html.parser")
    ptr = soup.find("td", attrs={"style": "font-weight: bold; font-size:15px"})

    while True :
        # Find matched populations
        if ptr.string == target :
            country = ptr.string
            population = ptr.next_sibling.next_sibling.string 
            break;
            
        # Search for next country
        parent = ptr.parent
        parent_next = parent.next_sibling.next_sibling
        if type(parent_next).__name__ != "Tag" : break
        ptr = parent_next.find("td", attrs={"style": "font-weight: bold; font-size:15px"})
    
    # Return the result
    return [country, population]
    
if __name__ == "__main__":
    # Get POST parameters
    params = cgi.FieldStorage()
    action = params.getvalue('action')
    country = params.getvalue('country')

    # Response
    print('Content-Type: text/html\n')

    # connect
    mydb = populationDB()
    if mydb.error != "" : 
        print(mydb.error)
        quit()   
        
    # Create
    if action == "Create" :
        result = get_population_from_web(country) 
        mydb.create(result[0], result[1])       
        if mydb.error != "" : 
            print(mydb.error) 
            quit() 
        print(result)
        print(" ... Created")
        
    # Read    
    elif action == "Read" :
        result = mydb.read(country)
        if mydb.error != "" : 
            print(mydb.error)
            quit() 
        print(result)
        
    # Update
    elif action == "Update" : 
        result = get_population_from_web(country)
        mydb.update(result[0], result[1])          
        if mydb.error != "" : 
            print(mydb.error)
            quit() 
        print(result)        
        if mydb.rowcount == 0 :
            print(" ... Not Found or Not Changed")
        else :
            print(" ... Updated")
            
    # Delete
    elif action == "Delete" : 
        mydb.delete(country) 
        if mydb.error != "" : 
            print(mydb.error)
            quit() 
        print(country) 
        if mydb.rowcount == 0 :
            print(" ... Not Found")
        else :
            print(" ... Deleted")
